

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>Calendar &mdash; Documentation</title>
  

  
  
    <link rel="shortcut icon" href="../../../_static/favicon.ico"/>
  
  
  

  
  <script type="text/javascript" src="../../../_static/js/modernizr.min.js"></script>
  
    
      <script type="text/javascript" id="documentation_options" data-url_root="../../../" src="../../../_static/documentation_options.js"></script>
        <script src="../../../_static/jquery.js"></script>
        <script src="../../../_static/underscore.js"></script>
        <script src="../../../_static/doctools.js"></script>
        <script crossorigin="anonymous" integrity="sha256-Ae2Vz/4ePdIu6ZyI/5ZGsYnb+m0JlOmKPjt6XZ9JJkA=" src="https://cdnjs.cloudflare.com/ajax/libs/require.js/2.3.4/require.min.js"></script>
        <script src="../../../_static/js/bootstrap.min.js"></script>
        <script src="../../../_static/js/bootstrap.bundle.min.js"></script>
        <script src="../../../_static/js/custom.js"></script>
    
    <script type="text/javascript" src="../../../_static/js/theme.js"></script>

    

  
  <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
  <link rel="stylesheet" href="../../../_static/pygments.css" type="text/css" />
  <link rel="stylesheet" href="../../../_static/css/bootstrap.min.css" type="text/css" />
  <link rel="stylesheet" href="../../../_static/css/bootstrap-grid.min.css" type="text/css" />
  <link rel="stylesheet" href="../../../_static/css/custom.css" type="text/css" />
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" />
    <link rel="next" title="TimeAxis" href="time_axis.html" />
    <link rel="prev" title="Time" href="time.html" /> 
</head>

<body class="wy-body-for-nav">

   
  <div class="wy-grid-for-nav">
    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
          

          
            <a href="../../../index.html" class="icon icon-home"> Shyft
          

          
          </a>

          
            
            
              <div class="version">
                4.12
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <p class="caption"><span class="caption-text">Project</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../project/what_is_shyft.html">What is Shyft?</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../project/get_involved.html">Get involved</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../project/contact.html">Contact</a></li>
</ul>
<p class="caption"><span class="caption-text">Time Series</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../concepts.html">Concepts</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="../getting_started.html">Getting started</a><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="time.html">Time</a></li>
<li class="toctree-l2 current"><a class="current reference internal" href="#">Calendar</a><ul>
<li class="toctree-l3"><a class="reference internal" href="#create-a-calendar-object">Create a Calendar object</a></li>
<li class="toctree-l3"><a class="reference internal" href="#calendar-and-time">Calendar and time</a></li>
<li class="toctree-l3"><a class="reference internal" href="#python-datetime-to-shyft-time">Python datetime to Shyft time</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="time_axis.html">TimeAxis</a></li>
<li class="toctree-l2"><a class="reference internal" href="time_series.html">TimeSeries</a></li>
<li class="toctree-l2"><a class="reference internal" href="dts.html">Distributed Time Series (DTS)</a></li>
<li class="toctree-l2"><a class="reference internal" href="notebooks.html">Examples</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Hydrology</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../hydrology/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../hydrology/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../hydrology/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../hydrology/api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Energy Market</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../energy_market/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../energy_market/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../energy_market/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../energy_market/api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Dashboard</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../dashboard/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../dashboard/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../dashboard/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../dashboard/api.html">API Documentation</a></li>
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../index.html">Shyft</a>
        
      </nav>


      <div class="wy-nav-content">
        
        <div class="rst-content">
        
          















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="../../../index.html">Docs</a> &raquo;</li>
        
          <li><a href="../getting_started.html">Getting started</a> &raquo;</li>
        
      <li>Calendar</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
            
            <a href="../../../_sources/content/time_series/getting_started/calendar.rst.txt" rel="nofollow"> View page source</a>
          
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  
<style>
/* CSS overrides for sphinx_rtd_theme */

/* 24px margin */
.nbinput.nblast.container,
.nboutput.nblast.container {
    margin-bottom: 19px;  /* padding has already 5px */
}

/* ... except between code cells! */
.nblast.container + .nbinput.container {
    margin-top: -19px;
}

.admonition > p:before {
    margin-right: 4px;  /* make room for the exclamation icon */
}

/* Fix math alignment, see https://github.com/rtfd/sphinx_rtd_theme/pull/686 */
.math {
    text-align: unset;
}
</style>
<div class="section" id="calendar">
<span id="usagecalendar"></span><h1>Calendar<a class="headerlink" href="#calendar" title="Permalink to this headline">¶</a></h1>
<p>The Shyft time series package provides a precise <code class="docutils literal notranslate"><span class="pre">Calendar</span></code> type that takes into account issues such as summer and
winter times as well as leap years. A <code class="docutils literal notranslate"><span class="pre">Calendar</span></code> instance is used to create <a class="reference internal" href="time_axis.html#usagetimeaxis"><span class="std std-ref">TimeAxis</span></a> objects which in
return are the foundation for the creation of <a class="reference internal" href="time_series.html#usagetimeseries"><span class="std std-ref">TimeSeries</span></a> objects.</p>
<div class="section" id="create-a-calendar-object">
<h2>Create a Calendar object<a class="headerlink" href="#create-a-calendar-object" title="Permalink to this headline">¶</a></h2>
<p>The creation of a <code class="docutils literal notranslate"><span class="pre">Calendar</span></code> object is straightforward as the following code snippet demonstrates.</p>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="kn">from</span> <span class="nn">shyft.time_series</span> <span class="kn">import</span> <span class="n">Calendar</span>

<span class="c1"># Create a utc-based calendar.</span>
<span class="n">utc</span> <span class="o">=</span> <span class="n">Calendar</span><span class="p">()</span>

<span class="c1"># Create a calendar representing a specific timezone.</span>
<span class="n">osl</span> <span class="o">=</span> <span class="n">Calendar</span><span class="p">(</span><span class="s2">&quot;Europe/Oslo&quot;</span><span class="p">)</span>

<span class="c1"># Create a calendar that has a fixed offset to UTC of 3600 sec (one hour).</span>
<span class="n">std</span> <span class="o">=</span> <span class="n">Calendar</span><span class="p">(</span><span class="mi">3600</span><span class="p">)</span> <span class="c1"># UTC+01</span>
</pre></div>
</div>
</div>
<div class="section" id="calendar-and-time">
<span id="usagecalendartime"></span><h2>Calendar and time<a class="headerlink" href="#calendar-and-time" title="Permalink to this headline">¶</a></h2>
<p>The calendar is integral in “understanding” time points. The <code class="docutils literal notranslate"><span class="pre">Calendar</span></code> object deals with all intricacies
of time zones without being cumbersome.</p>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="kn">from</span> <span class="nn">shyft.time_series</span> <span class="kn">import</span> <span class="n">Calendar</span>

<span class="c1"># define the calendar for Oslo</span>
<span class="n">osl</span> <span class="o">=</span> <span class="n">Calendar</span><span class="p">(</span><span class="s2">&quot;Europe/Oslo&quot;</span><span class="p">)</span>

<span class="c1"># A Calendar is more informative than the usual time zone</span>
<span class="n">osl</span><span class="o">.</span><span class="n">tz_info</span><span class="o">.</span><span class="n">name</span><span class="p">()</span>            <span class="c1"># &quot;Europe/Oslo&quot;</span>
<span class="n">osl</span><span class="o">.</span><span class="n">tz_info</span><span class="o">.</span><span class="n">base_offset</span><span class="p">()</span>     <span class="c1"># time(3600)</span>

<span class="c1"># List of all the region ID&#39;s available</span>
<span class="nb">print</span><span class="p">(</span><span class="nb">list</span><span class="p">(</span><span class="n">Calendar</span><span class="o">.</span><span class="n">region_id_list</span><span class="p">()))</span>

<span class="c1"># Get the UTC epoch timestamp for a point in time in Oslo</span>
<span class="c1"># Please note that this is 1 hour before local DST change</span>
<span class="c1"># NOTE: minutes, seconds, microseconds also possible</span>
<span class="n">t0</span> <span class="o">=</span> <span class="n">osl</span><span class="o">.</span><span class="n">time</span><span class="p">(</span><span class="mi">2021</span><span class="p">,</span> <span class="mi">3</span><span class="p">,</span> <span class="mi">28</span><span class="p">,</span> <span class="mi">1</span><span class="p">)</span>        <span class="c1"># 2021-03-28T00:00:00Z</span>

<span class="c1"># Calendars has a `to_string` function which gives a ISO8601 string</span>
<span class="nb">print</span><span class="p">(</span><span class="n">osl</span><span class="o">.</span><span class="n">to_string</span><span class="p">(</span><span class="n">t0</span><span class="p">))</span>             <span class="c1"># 2021-03-28T01:00:00+01</span>

<span class="c1"># Add fixed time period</span>
<span class="c1"># This will add an absolute amount of time aka day = 86400 seconds</span>
<span class="n">t1</span> <span class="o">=</span> <span class="n">t0</span> <span class="o">+</span> <span class="n">Calendar</span><span class="o">.</span><span class="n">DAY</span>               <span class="c1"># 2021-03-29T00:00:00Z</span>

<span class="c1"># Add time period through the calendar (aware of DST change)</span>
<span class="c1"># WARNING: this will miss an hour in absolute terms</span>
<span class="n">t2</span> <span class="o">=</span> <span class="n">osl</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">t0</span><span class="p">,</span> <span class="n">Calendar</span><span class="o">.</span><span class="n">DAY</span><span class="p">,</span> <span class="mi">1</span><span class="p">)</span>    <span class="c1"># 2021-03-28T23:00:00Z</span>

<span class="c1"># Subtraction works similarly.</span>
<span class="c1"># t3 is equal to t0.</span>
<span class="n">t3</span> <span class="o">=</span> <span class="n">osl</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">t2</span><span class="p">,</span> <span class="n">Calendar</span><span class="o">.</span><span class="n">DAY</span><span class="p">,</span> <span class="o">-</span><span class="mi">1</span><span class="p">)</span>

<span class="c1"># Analyse time point differences</span>
<span class="c1"># WARNING: This rounds down</span>
<span class="n">osl</span><span class="o">.</span><span class="n">diff_units</span><span class="p">(</span><span class="n">t0</span><span class="p">,</span> <span class="n">t1</span><span class="p">,</span> <span class="n">Calendar</span><span class="o">.</span><span class="n">DAY</span><span class="p">)</span>    <span class="c1"># 1</span>
<span class="n">osl</span><span class="o">.</span><span class="n">diff_units</span><span class="p">(</span><span class="n">t0</span><span class="p">,</span> <span class="n">t1</span><span class="p">,</span> <span class="n">Calendar</span><span class="o">.</span><span class="n">WEEK</span><span class="p">)</span>   <span class="c1"># 0</span>
<span class="n">osl</span><span class="o">.</span><span class="n">diff_units</span><span class="p">(</span><span class="n">t0</span><span class="p">,</span> <span class="n">t1</span><span class="p">,</span> <span class="n">Calendar</span><span class="o">.</span><span class="n">MONTH</span><span class="p">)</span>  <span class="c1"># 0 (!)</span>

<span class="c1"># Analyse time points</span>
<span class="n">osl</span><span class="o">.</span><span class="n">tz_info</span><span class="o">.</span><span class="n">is_dst</span><span class="p">(</span><span class="n">t0</span><span class="p">)</span>            
<span class="c1"># returns True if daylight saving time, False otherwise</span>
<span class="n">osl</span><span class="o">.</span><span class="n">tz_info</span><span class="o">.</span><span class="n">utc_offset</span><span class="p">(</span><span class="n">t0</span><span class="p">)</span>  <span class="c1"># time(3600)</span>
<span class="n">osl</span><span class="o">.</span><span class="n">quarter</span><span class="p">(</span><span class="n">t0</span><span class="p">)</span>             <span class="c1"># 1</span>
<span class="n">osl</span><span class="o">.</span><span class="n">day_of_year</span><span class="p">(</span><span class="n">t0</span><span class="p">)</span>         <span class="c1"># 87</span>

<span class="c1"># Calendars can be used to determine notable time points</span>
<span class="c1"># rounds the timestamp down to the beginning of the day</span>
<span class="n">d</span> <span class="o">=</span> <span class="n">osl</span><span class="o">.</span><span class="n">trim</span><span class="p">(</span><span class="n">t0</span><span class="p">,</span> <span class="n">Calendar</span><span class="o">.</span><span class="n">DAY</span><span class="p">)</span>
<span class="c1"># 2021-03-27T23:00:00Z aka 2021-03-28 00:00 OSL in UTC</span>

<span class="c1"># rounds the timestamp down to the beginning of the iso week (Monday)</span>
<span class="n">w</span> <span class="o">=</span> <span class="n">osl</span><span class="o">.</span><span class="n">trim</span><span class="p">(</span><span class="n">t0</span><span class="p">,</span> <span class="n">Calendar</span><span class="o">.</span><span class="n">WEEK</span><span class="p">)</span>
<span class="c1"># 2021-03-21T23:00:00Z aka 2021-03-22 00:00 OSL in UTC</span>

<span class="c1"># rounds the timestamp down to the beginning of the month</span>
<span class="n">m</span> <span class="o">=</span> <span class="n">osl</span><span class="o">.</span><span class="n">trim</span><span class="p">(</span><span class="n">t0</span><span class="p">,</span> <span class="n">Calendar</span><span class="o">.</span><span class="n">MONTH</span><span class="p">)</span>
<span class="c1"># 2021-02-28T23:00:00Z aka 2021-03-01 00:00 OSL in UTC</span>

<span class="c1"># rounds the timestamp down to the beginning of the quarter</span>
<span class="n">q</span> <span class="o">=</span> <span class="n">osl</span><span class="o">.</span><span class="n">trim</span><span class="p">(</span><span class="n">t0</span><span class="p">,</span> <span class="n">Calendar</span><span class="o">.</span><span class="n">QUARTER</span><span class="p">)</span>
<span class="c1"># 2020-12-31T23:00:00Z aka 2021-01-01 00:00 OSL in UTC</span>
</pre></div>
</div>
<p>Other methods to translate UTC epoch time stamps and date time using a <code class="docutils literal notranslate"><span class="pre">Calendar</span></code> instance.
For more information see <a class="reference external" href="https://en.wikipedia.org/wiki/ISO_week_date">Wikipedia - ISO week date</a>.</p>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="c1"># 2020-12-31T23:00:00Z aka 2021-01-01 00:00 OSL in UTC</span>

<span class="c1"># rounds the timestamp down to the beginning of the year</span>
<span class="n">y</span> <span class="o">=</span> <span class="n">osl</span><span class="o">.</span><span class="n">trim</span><span class="p">(</span><span class="n">t0</span><span class="p">,</span> <span class="n">Calendar</span><span class="o">.</span><span class="n">YEAR</span><span class="p">)</span>
<span class="c1"># 2020-12-31T23:00:00Z aka 2021-01-01 00:00 OSL in UTC</span>


<span class="kn">from</span> <span class="nn">shyft.time_series</span> <span class="kn">import</span> <span class="n">Calendar</span>

<span class="c1"># define the calendar for Oslo</span>
<span class="n">osl</span> <span class="o">=</span> <span class="n">Calendar</span><span class="p">(</span><span class="s2">&quot;Europe/Oslo&quot;</span><span class="p">)</span>

<span class="c1"># Create from ISO week information (year, iso week number, iso day number)</span>
<span class="c1"># NOTE: hours, minutes, seconds, microseconds also possible</span>
<span class="n">t0</span> <span class="o">=</span> <span class="n">osl</span><span class="o">.</span><span class="n">time_from_week</span><span class="p">(</span><span class="mi">2021</span><span class="p">,</span> <span class="mi">34</span><span class="p">,</span> <span class="mi">1</span><span class="p">)</span>

<span class="c1"># The reverse is also possible</span>
</pre></div>
</div>
</div>
<div class="section" id="python-datetime-to-shyft-time">
<h2>Python datetime to Shyft time<a class="headerlink" href="#python-datetime-to-shyft-time" title="Permalink to this headline">¶</a></h2>
<p>As outlined in the chapter <a class="reference internal" href="../concepts/time.html#concepttime"><span class="std std-ref">Dealing with time</span></a>, only epoch time stamps are truly unique and native Python <code class="docutils literal notranslate"><span class="pre">datetime</span></code>
objects have difficulties when dealing with time zones.</p>
<p>Once in the Shyft space, you are safe, but the translation is unfortunately your responsibility.</p>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="n">cal_2</span> <span class="o">=</span> <span class="n">osl</span><span class="o">.</span><span class="n">calendar_units</span><span class="p">(</span><span class="n">t0</span><span class="p">)</span>

<span class="c1"># Calendar instances also allow for conversion between time zones</span>
<span class="n">lap</span> <span class="o">=</span> <span class="n">Calendar</span><span class="p">(</span><span class="s2">&quot;America/La_Paz&quot;</span><span class="p">)</span>
<span class="n">cal_3</span> <span class="o">=</span> <span class="n">lap</span><span class="o">.</span><span class="n">calendar_units</span><span class="p">(</span><span class="n">t0</span><span class="p">)</span>   <span class="c1"># returns YMDhms(2021,8,22,18,0,0)</span>


<span class="kn">from</span> <span class="nn">datetime</span> <span class="kn">import</span> <span class="n">datetime</span>
<span class="kn">from</span> <span class="nn">pytz</span> <span class="kn">import</span> <span class="n">timezone</span>
<span class="kn">from</span> <span class="nn">shyft.time_series</span> <span class="kn">import</span> <span class="n">Calendar</span><span class="p">,</span> <span class="n">time</span>

<span class="c1"># The Python native datetime must be given a time zone</span>
<span class="c1"># or it is interpreted as your computer&#39;s local time zone.</span>
<span class="n">tz</span> <span class="o">=</span> <span class="n">timezone</span><span class="p">(</span><span class="s2">&quot;Europe/Oslo&quot;</span><span class="p">)</span>
<span class="n">dt</span> <span class="o">=</span> <span class="n">datetime</span><span class="p">(</span><span class="mi">2021</span><span class="p">,</span> <span class="mi">3</span><span class="p">,</span> <span class="mi">28</span><span class="p">,</span> <span class="mi">1</span><span class="p">)</span>
<span class="n">dt_tz</span> <span class="o">=</span> <span class="n">tz</span><span class="o">.</span><span class="n">localize</span><span class="p">(</span><span class="n">dt</span><span class="p">)</span>
</pre></div>
</div>
</div>
</div>


           </div>
           
          </div>
          <footer>
  
    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
      
        <a href="time_axis.html" class="btn btn-neutral float-right" title="TimeAxis" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right"></span></a>
      
      
        <a href="time.html" class="btn btn-neutral float-left" title="Time" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left"></span> Previous</a>
      
    </div>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2021, The Shyft project

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/rtfd/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script>

  
  
    
   

</body>
</html>